# coding: utf-8

"""
    Insights Service API -test

    ## Introduction to PlotRisk  PlotRisk is a module, which ease to create plot for the given area of interest and also   facilitate to check satellite indices, weather and yield data.    **Note**``  Indices, Weather and Yield data can be accessed based on features subscriptions.  ``  ## Resources  A resource is an entity that has a set of exposed operations. The entity can represent an actual object (account, users..) or a set of logical operations collated together. It is up to the specification user to decide whether sub-resources should be referred to as part of their main resource or as a resource of their own. For example, assume the following URL set:     ```    /users         -GET                   POST                    /users/{id}    -GET                   PATCH                   DELETE   ```  For more details, see [CRUD Operations](https://docs.microsoft.com/en-us/iis-administration/api/crud) to learn more about it.  ## Trying the API  You can use [Swagger UI](https://swagger.io/tools/swagger-ui/) or any third party client such as ,[Postman](https://www.postman.com/), [cURL](https://curl.se/) etc. to test the REST API.    **Swagger UI**    **Step 1.** Generate access tokens using **/token** resource      **Info** : ``If you are a SMARTFARM_PLUS user, you can request for tokens using tenant,username,password  ``    **Step 2.** Copy **_access_token_** from **Step 1**, then click on **Authorize** button and paste the token.    **Step 3.** Select an API resource and click on **_Try it out_**.    **Step 4.** Fill the headers such as _**TenantType**_, _**OrgId**_ & _**X-Api-Key**_.    **Info** : ``X-Api-Key can be obtained from Step 1  ``    **Step 5.**  Query parameters are optional. It filters result based on provided parameter value.  ```   e.g.   {           \"size\": 300,           \"page\": 0,          }             e.g.   {          }            ```   **Step 6.** Click on **Execute**    **Curl**  ```  curl -X 'GET' \\  'http://localhost:8085/api/v1/crops' \\  -H 'accept: application/json' \\  -H 'TenantType: SMARTRISK' \\  -H 'orgId: test' \\  -H 'X-Api-Key: qwjokooopppp' \\  -H 'Authorization: Bearer jklkopalkddlplplllllllllll2340k'  ```  Using a graphical tool such as Postman, it is possible to import the API specifications directly:    - Download the API specification by clicking the **swagger.json** hypelink at top of this document  - Import the JSON specification in the graphical tool of your choice.  - In *Postman*, you can click the import button at the top    ## Authentication  The API authentication process validates the identity of the client attempting to make a connection by using an authentication protocol.  **Access Token** is required to access PlotRisk APIs & same can be generated by following API on passing valid request payload (see Token API)  ```  POST   /tokens  ```    For more details, see [Authentication and Authorization](https://swagger.io/docs/specification/authentication/).    ## Errors  The REST API reports errors by returning an appropriate HTTP response code, for example 404 (Not Found), and a JSON response. Any HTTP response code that is not in the range 200 - 299 is considered an error.    For more details on HTTP Status code, see [HTTP Status Codes](https://restfulapi.net/http-status-codes/)   # noqa: E501

    OpenAPI spec version: v1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class YieldsData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'yield_min': 'str',
        'yield_max': 'str',
        'yield_avg': 'str',
        'planned_harvest_projection': 'str'
    }

    attribute_map = {
        'yield_min': 'yieldMin',
        'yield_max': 'yieldMax',
        'yield_avg': 'yieldAvg',
        'planned_harvest_projection': 'plannedHarvestProjection'
    }

    def __init__(self, yield_min=None, yield_max=None, yield_avg=None, planned_harvest_projection=None):  # noqa: E501
        """YieldsData - a model defined in Swagger"""  # noqa: E501
        self._yield_min = None
        self._yield_max = None
        self._yield_avg = None
        self._planned_harvest_projection = None
        self.discriminator = None
        if yield_min is not None:
            self.yield_min = yield_min
        if yield_max is not None:
            self.yield_max = yield_max
        if yield_avg is not None:
            self.yield_avg = yield_avg
        if planned_harvest_projection is not None:
            self.planned_harvest_projection = planned_harvest_projection

    @property
    def yield_min(self):
        """Gets the yield_min of this YieldsData.  # noqa: E501


        :return: The yield_min of this YieldsData.  # noqa: E501
        :rtype: str
        """
        return self._yield_min

    @yield_min.setter
    def yield_min(self, yield_min):
        """Sets the yield_min of this YieldsData.


        :param yield_min: The yield_min of this YieldsData.  # noqa: E501
        :type: str
        """

        self._yield_min = yield_min

    @property
    def yield_max(self):
        """Gets the yield_max of this YieldsData.  # noqa: E501


        :return: The yield_max of this YieldsData.  # noqa: E501
        :rtype: str
        """
        return self._yield_max

    @yield_max.setter
    def yield_max(self, yield_max):
        """Sets the yield_max of this YieldsData.


        :param yield_max: The yield_max of this YieldsData.  # noqa: E501
        :type: str
        """

        self._yield_max = yield_max

    @property
    def yield_avg(self):
        """Gets the yield_avg of this YieldsData.  # noqa: E501


        :return: The yield_avg of this YieldsData.  # noqa: E501
        :rtype: str
        """
        return self._yield_avg

    @yield_avg.setter
    def yield_avg(self, yield_avg):
        """Sets the yield_avg of this YieldsData.


        :param yield_avg: The yield_avg of this YieldsData.  # noqa: E501
        :type: str
        """

        self._yield_avg = yield_avg

    @property
    def planned_harvest_projection(self):
        """Gets the planned_harvest_projection of this YieldsData.  # noqa: E501


        :return: The planned_harvest_projection of this YieldsData.  # noqa: E501
        :rtype: str
        """
        return self._planned_harvest_projection

    @planned_harvest_projection.setter
    def planned_harvest_projection(self, planned_harvest_projection):
        """Sets the planned_harvest_projection of this YieldsData.


        :param planned_harvest_projection: The planned_harvest_projection of this YieldsData.  # noqa: E501
        :type: str
        """

        self._planned_harvest_projection = planned_harvest_projection

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(YieldsData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, YieldsData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
